﻿@page
@using Management.Entities;
@using Management.BusinessLogic;
@model IndexModel
@{
    /* Constants */
    ViewData["Title"] = "Export";
    const uint itemPerPage = 10;

    /* Default value */
    uint pageIndex = 1;
    uint pageTotal = 1;
    uint noStart = 1;
    uint noEnd = 1;
    uint noTotal = 1;
    string sKeyword = string.Empty;

    /* Try get page index */
    uint.TryParse(Request.Query["page"], out pageIndex);

    /* Get search keyword */
    sKeyword = Request.Query["search"];

    /* Read the export list */
    Export[] exportList = BUS_Export.ReadList(sKeyword);

    if (exportList.Length > 0)
    {
        /* Calculate the number of pages based on the total number of export order in the list */
        pageTotal = ((uint)exportList.Length - 1) / itemPerPage + 1;

        /* Check page index exceptions */
        if (pageIndex == 0 || pageIndex > pageTotal)
        {
            pageIndex = 1;
        }

        /* Calculate the Index of the export order that will be displayed */
        noStart = (pageIndex - 1) * itemPerPage + 1;
        noEnd = noStart + itemPerPage - 1;
        noTotal = (uint)exportList.Length;
        if (pageIndex == pageTotal)
        {
            noEnd = noStart + ((uint)exportList.Length - 1) % itemPerPage;
        }
    }
}

<div class="row text-start">
    <p>
        <a href="/" class="link-primary text-decoration-none">Home</a>
        >
        <a href="/export" class="link-primary text-decoration-none">Export</a>
    </p>
</div>
<div>
    <div class="row table_header mb-2">
        <p class="col-sm-3 mb-2 text-start fw-bold">Export Details</p>
        <div class="col-sm-6 mb-2 text-start text-sm-center d-inline-block">
            <form method="get">
                <input type="text" id="search" name="search" value="@sKeyword" placeholder="ID or User" maxlength="30" />
                <button type="submit" value="Search" class="btn btn-sm btn-primary text-light">Search</button>
            </form>
        </div>
        <div class="col-sm-3 mb-2 text-start text-sm-end">
            <a target="_blank" class="btn btn-sm btn-success text-light" href="/export/add" role="button">Add New</a>
        </div>
    </div>
    <div class="text-center table_section">
        <table class="table table-bordered table-striped table-hover align-middle">
            <thead>
                <tr>
                    <th>No</th>
                    <th>ID</th>
                    <th>User</th>
                    <th>Date</th>
                    <th>Action</th>
                </tr>
            </thead>

            <tbody>
                @if (exportList.Length > 0)
                {
                    uint j = noStart - 1;
                    for (uint i = noStart; i <= noEnd; i++)
                    {
                        <tr>
                            <td>@i</td>
                            <td>@exportList[j].ID</td>
                            <td>@exportList[j].User</td>
                            <td>@exportList[j].Date</td>
                            <td>
                                <a target="_blank" class="btn btn-sm btn-info text-light" href="/export/view?id=@exportList[j].ID" role="button">View</a>
                                <a target="_blank" class="btn btn-sm btn-warning text-light" href="/export/edit?id=@exportList[j].ID" role="button">Edit</a>
                            </td>
                        </tr>
                        j++;
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5" class="text-center fw-bold">No data available</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>

    <div class="row table_pagination">
        @if (exportList.Length > 0)
        {
            <div class="col-3">
                <p class="pagination">From @noStart to @noEnd of @noTotal</p>
            </div>
            <div class="col-9">
                <nav aria-label="Page navigation">
                    <ul class="pagination justify-content-end">
                        @for (uint i = 1; i <= pageTotal; i++)
                        {
                            if (i == pageIndex)
                            {
                                <li class="page-item active"><a class="page-link" href="/export/?search=@sKeyword&page=@i">@i</a></li>
                            }
                            else
                            {
                                <li class="page-item"><a class="page-link" href="/export/?search=@sKeyword&page=@i">@i</a></li>
                            }
                        }
                    </ul>
                </nav>
            </div>
        }
    </div>
</div>

